(*********************************************************************

	Cool`Arrowise`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995/97 Thomas Cool *)
(* :Package Version: 1.05 Thomas Cool, December 1997.*)
(* :Mathematica Version: 2.2.2 *)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of packs. See the License[] function. *)
(* :Keywords:    *)
(* :Limitation:
*)

Needs["Cool`Common`"]

BeginPackage["Cool`Arrowise`", Join[{"Graphics`Arrow`"}, $Cool]]

ArrowiseQ = "Use the package as follows:\n1) Start with ResetNodes.\n2) Then you give Node[label1, Text[...1...]]; Node[label2, Text[...2...]]; .... statements. Each statement associates a label with its text, and fills the NodeLabels and Nodes memory. Text is the normal Mathematica Graphics primitive.\n3) Then you may give two kinds of lists of rules:\n   BlackArrowRules = {labeli -> labelj, ... }\n   HueArrowRules[r] = {labelk -> labeln, ....}\n   Such rule statements li -> lj will later be translated in arrows for the associated nodes. Here, r will be a real number from 0 till 1, giving a hue. (See Rainbow.)\n4) The results can be shown by ShowAll, or separately by ShowBlackArrows, ShowHueArrows[r] or [{r1, r2,...}], and finally ShowText. Options in these commands are passed on to Show."

ArrowiseQ::usage = "ArrowiseQ tells you how to use the Arrowise package."

BlackArrow::usage = "BlackArrow[x_, y_] gives a Graphics primitive for a black arrow from x[[2]] to y[[2]]."

BlackArrowRules::usage = "List of rules, which will become black arrows"

HueArrow::usage = "HueArrow[x_, y_, r_] Graphics primitive. An arrow from Node[x][[2]] to Node[y][[2]] with Hue[r]."

HueArrowRules::usage = "HueArrowsRules[r] is a list of rules, which will become arrows with Hue r"

Node::usage  = "Node[x_, Text[...]] associates label x with the Text item."

NodeLabels::usage = "List of the Node labels, corresponding to Nodes"

ResetNodes::usage = "ResetNodes sets NodeLabels and Nodes to {}."

Nodes::usage = "List of Text elements {Text[ ...], Text[ ... ], ... }, corresponding to NodeLabels"

ShowAll::usage = "ShowAll[r_List:{}, opts___Rule] submits the data in memory to Show. The various Hues may be given in a list. Text is shown last, thereby printing over."

ShowBlackArrows::usage = "ShowBlackArrows[opts___Rule] submits BlackArrows to Show"

ShowHueArrows::usage = "ShowHueArrows[r_, opts___Rule] submits the associated list to Show. If r is a list of Hues, then the elements are shown separately."

ShowText::usage = "ShowText[opts___Rule] submits Nodes to Show"

Contours::usage = Key[AddedUsage, Contours, "Option of ShowPath:\nContours -> False gives no contours; Contours -> {number, type} with number 1 or All, and All gives as much as there are points in the Path, type is Plus or Times, giving contours of x+y or x*y values"];

Options[ShowPath] = {Contours -> False}

ShowPath::usage = "ShowPath[x_List, y_List, (t_List,) (r_,) opts___Rule] gives a path of chained arrows, for lists of x and y co-ordinates, with possibly t text expressions, and hue r (0 <= r <= 1), and with opts passed on to Show.\nShowPath[Log, x_List, y_List, (t_List,)  opts___Rule] gives a {Log[x], Log[y]} plot, with loglinear contours of x * y = constant."

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
