(******************************************************************

	Cool`Cartel`  package


 ******************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Thomas Cool *)
(* :Package Version: 1.01, June 1998.*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:  Economics  *)
(* :Limitation:  *)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of packs. See the License[] function. *)
(* :Comments: the Aggregator initially defines on itself *)


Needs["Cool`Common`"]

BeginPackage["Cool`Cartel`", Join[{"Cool`Economic`Common`"}, $Cool]]

Partner::usage = "Keyword, used to identify partners in the cartel.
\n(1) After SetCartel[] then Partner[i][Cost, qi] gives the cost of partner i in producing qi
\n(2) In the output of SetCartel the rule Partner[N] -> ... gives the number of partners"


Cartel::usage = "After SetCartel[]:
\nCartel[N] the number of partners
\nCartel[Partner, q] the allocation over the partners when production is q
\nCartel[Cost, q] the cost for the partners when production is q
\nCartel[Profit, p] the profit for the partners when the price is p
\nCartel[Price] the optimal price for the cartel
\nCartel[Price, p] the cartel situation when the price is p
\nCartel[] gives the situation at the optimal price"

SetCartel::usage = "SetCartel[Kind, {A, e (, pstar, h)}, {parms__List}, x0:80, x1:3000]
\n(1) sets the demand function to LinExp[p, {A, e, pstar, h}], see FixedLinExp; if called with only A and e, then pstar = 1 and h = 0
\n(2) defines the cost functions of the different partners, where each 
parameter list is {c0, c1, c2, ...} and gives polynomial cost[i] = c0 + c1 q[i] + c2 q[i]^2 + ...
\n(3) solves for the optimal price and derives the allocation of production 
over the partners. Here, x0 and x1 are the range values for FindRoot
\n(4) sets the different values for Cartel[...], see there.
\n(*) When Kind = Plus, then the cost functions are added, and each produces at the same marginal cost,\nwhen Kind = Min then the minimal cost producer is selected (and the others are zero)"

FixedLinExp::usage = "FixedLinExp[Price -> p] gives the demand quantity of LinExp[p, {parameters}] as set in the call of SetMonopoly or SetCartel. Note: This function enables the use of the default Cost[] and Profit[Price -> p] calls in conjunction with the option settings, also for arbitrary numbers of partners" 

Monopoly::usage = "After SetMonopoly[]:
\nMonopoly[Cost, q] the cost when production is q
\nMonopoly[MarginalCost, q] the marginal cost when production is q
\nMonopoly[Profit, p] the profit when the price is p
\nMonopoly[Price] the optimal price
\nMonopoly[Price, p] the situation when the price is p
\nMonopoly[] gives the situation at the optimal price"


SetMonopoly::usage = "SetMonopoly[{A, e (, pstar, h)}, costparameters__List, x0:80, x1:3000] \n(1) sets the demand function to LinExp[p, {A, e, pstar, h}], see FixedLinExp; if called with only A and e, then pstar = 1 and h = 0\n(2) defines the cost function, where {c0, c1, c2, ...} gives polynomial cost[i] = c0 + c1 q + c2 q^2 + ... \n(3) solves for the optimal price and production. Here, x0 and x1 are the range values for FindRoot \n(4) sets the different values for Monopoly[...]"

MonopolyModel::usage = "MonopolyModel[x___Rule] is a SolveFrom application. Rule Exponent -> {A, a, pstar, h} sets the values for the LinExp function, CoefficientList -> {c1, c2, c3, ...} sets the coefficients for polynomial costs (seen as a function of production q). Set other values as you please. This is actually a more flexible format than SetMonopoly[], since it allows one to e.g. solve for arbitrary coefficients such as A, a, ... given the level of Production and Price."




Shares::usage = "(1) Shares[criterion, c_List] reallocates profits of c = Cartel[] formats according to the given criterion.
\n
\nPossible criteria are:
\nEqual: the shares are taken as 1/n, with n the number of partners
\n{share1, share2, ...}: a plain list of shares (if not adding up to 1, then it is divided by the sum of these shares)
\nCost: take the shares in the total cost
\nProduction: take the shares in production
\n
\nOutput is:
\nProfit: the total profit that is to be divided
\nRule: the division rule
\nShare: the shares when applying that rule
\nIn: the profits earned by every partner by his sales
\nOut: profits as they should be after redistribution
\nRe: the actual redistribution (Out - In). A positive value is a receipt from the clearing agent, a negative value is a payment to the clearing agent\n
\n
\n(2) Shares[c_List] transforms c = Cartel[] formats into a format with shares per partner"


Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
