(*********************************************************************

	Cool`Chaindex`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995/97 Thomas Cool *)
(* :Package Version: 2.01,  October 1997.*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:    *)
(* :Limitation: *)
(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`Chaindex`", Join[{}, $Cool]]

Chain::usage = "Chain[x, position] chains a unit change vector while normalizing to 1 in position. If no position is given, then the first place is taken."

ChainIndex::usage = "ChainIndex[q_List, p_List (, position)] gives a chain index for a list of quantities q and a list of associated price indices p. Elements q[[i]] and p[[i]] must be vectors. Position is the position in the price vectors that is normalized to 1; if no value is given, it is set at the first position.\nSteps in the chaining are:\n1) w = p * q gives values, and summing then gives aggregate wtot,\n2) pu = UnitIndex[p] are the periodic unit price changes,\n3) v = w / pu deflates to volumes (value in terms of last period prices),\n4) summing volumes gives aggregate volume, and (aggregate) value / volume gives the periodic unit price change for the aggregate,\n5) chaining the aggregate unit price changes gives aggregate ptot, and chained volume ctot = wtot / ptot (in prices of the base year),\n6) output is the pair {ctot, ptot}.\nDiscussion: The result is a (chained) Laspeyres volume and Paasche price index. This method is favoured by the Dutch Central Planning Bureau since volume and price changes add up to value changes, and since the choice of a different base period does not lead to different data for the aggregate rates of change. A consequence is that the aggregate volume index differs from the sum of the q.\nMissing data can be represented by Indeterminate."

ChainIndexTable::usage = "ChainIndexTable[q_List, p_List (, position)] performs the same computation as ChainIndex, but gives fuller data lists (see Results[ChainIndexTable], and prints the results in tabular form. The meaning of the columns is:\n   wn-1 = lagged value in levels\n   vd = volume change in level\n   vp = volume change in percentage\n   vn = volume level (in prices last period)\n   pd = price change in level\n   pp = price change in percentage of vn\n   wn = value in level, current prices"


Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
