(*********************************************************************

	Cool`CrossTable`  package


 *********************************************************************)



(* :Author: Thomas Cool *) 
(* :Copyright: Copyright 1993/95 Thomas Cool *)
(* :Package Version: 2.0 Thomas Cool, June 1997 *)
(* :Mathematica Version: 3.0.0. *)
(* :Keywords:      *)
(* :Limitation:
*)
(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`CrossTable`", Join[{"Cool`Statistics`Common`", "Cool`Chi2`", "Statistics`NormalDistribution`", "Statistics`Common`DistributionsCommon`", "Statistics`DataManipulation`", "Statistics`DescriptiveStatistics`"}, $Cool]]


$KBCrossTable = Key[Begin, "Cool`Statistics`Common`", $Context]

AddedUsage[{Position, Show, Frequencies, Variables, In, Context}]


(*******
begin option labels
*******)


BorderWeight::usage = "Output option of Make: the border sums of the weights."

CrossEntries::usage = "Output option of Make: the outer product of Categories."

CrossEntriesQ::usage = "Input option of Make: if the CrossEntries are required in output. Default is False."

CrossWeight::usage = "The count of weights:\n1) as an output option of Make giving the list,\n2) CrossWeight[..,..,..] gives a cell. "

(****
end option labels
*****)

CrossOutliers::usage = "CrossOutliers[k, rule_List] performs Outliers on crosstable data and gives the selection of inner cells. Required are keywords CrossEntries, CrossTable, ProbabilityMatrix and NumberOfObservations."

Options[Make] = {Context -> "Global`", Position -> All, Weight -> Null, WeightUnit -> DivSmallestNonZero, CrossEntriesQ -> False }

Make::usage = "Make[rawdata_List, opts___Rule]\n  makes a list of rules containing all basic information about a crosstable of the rawdata. Rawdata normally is a list of vectors of equal length. It can be a list of Strings too (i.e. the names of variables that contain such vectors), and then the names are concatenated with the Context in current options; in this manner a structural form can be given for various contexts.\nOne may select some of the values, by a position list in the options, generated by Position or Places. If weights in the option Weigtht -> ... are set (by a list or a variable name), then weights are computed too. The output can be inputted in LLRStatistics, and/or be used in a Chi2 test like in QuickTest. Output can be shown by ShowCT."

Options[MakeAndSave] = {File -> {"C:\\Math3.0\\Dump\\", 2, "crosst"}}

MakeAndSave::usage = "MakeAndSave[kRange, rawdata_List, opts___Rule]\n  computes a crosstable for the rawdata, performs the likelihood ratio test on full independence, gives the outliers in kRange, and writes results to file. Default are Options[Make] and Options[MakeAndSave]. See Make for rawdata and opts. See Outliers for kRange. The filename can be given as File -> String, or File -> {dir_String, n_Integer, name_String}. The integer gives the first places of the Context name as specified by the options. The preferred file type is \".mac\"."

LLRStatistics::usage = "LLRStatistics[rules_List, controlopts___Rule] gives the likelihood ratio test statistics on independence, using the output of Make. If QuickTest -> True, default, the Full ID formula is used. When weights are present, the results thereof are collected under Weight -> . Note that here the probabilities are taken from the weights, but the powers from the frequencies, since these have objective value. The same control options are used as for Cool`Chi2`Test, excluding Partition. LLRStatistics[Table||Weight] contain the log likelihood ratio cells, when QuickTest -> False. See PrEst[ID, Table||Weight] when Show -> None. The output is in the form of a list of rules."

QuickTest::usage = "1) QuickTest[ID, r_List] applies a quick likelihood ratio test on independence e.g. on the output of Make. The Full ID statistic is used.\n2) Option for LRRStatistics. QuickTest -> True, default, means that only the Full ID statistic is used, and that the cell ratios are not computed."

ShowCT::usage = "ShowCT[rules_, type_:1] \n takes a list of rules as input and prints the crosstable with TableForm. Type is a code for predefined outputs.\nTheoretical values are in levels, i.e. probabilities times the number of observations.\nWhen theoretical probabilities or weights are not in the list, but according to the type code should be used, then values are taken from PrEst[ID, Table||Weight] and LLRStatistics[Table||Weight].\nNon-integer data are rounded till .1. You may use width printing (Menu-Options-Action) or try PaddedForm to get a neat output.\nType codes are:\n1: cases observed,\n2: cases, observed and theory\n3: cases and weights, observed\n4: cases and weights: observed and theory\n5: weights: observed and theory."

Cool`Statistics`Common`Test::usage = Key[AddedUsage, Test, "Test[ID, Make, r_List, opts___Rule] uses output of Make, and if weights are present, then performs a double test. LLRStatistics results are not in output but stored under LLRStatisticsOut"]

LLRStatisticsOut::usage = "LLRStatisticsOut stores results from LLRStatistics, when Test[ID, Make, ...] has been evaluated"


Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
