(*********************************************************************

	Cool`Data`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1997 Thomas Cool *)
(* :Package Version: 1.00,  January 1997.*)
(* :Mathematica Version: 2.2.2 *)
(* :Keywords:    *)
(* :Limitation: *)
(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`Data`", Join[{"Cool`Dbase`"}, $Cool]]

BeginYear::usage = "BeginYear[x, label] gives the begin year of data symbol x. BeginYear[label] gives the maximal begin year in the data defined up to the last SetData statement, for which all data are present. BeginYear[x_list, label] computes a begin year from the list (but this is not reset to BeginYear[label]. Also see ResetData."


BaseYear::usage = "BaseYear[concept] gives the current value of the year for which the price index of the concept is 1. BaseYear[All] or BaseYear[] would be generic"

Concepts::usage = "Concepts[x] gives a list of Symbols on the label x. At StartUp, Concepts[] = {}";

Concepts[] = {};

Data::usage = Key[AddedUsage, Data, "Data[x, label] contains data for the variate x with the given label. The data are a list of values from BeginYear till EndYear."];

EndYear::usage = "EndYear[x] gives the end year of data symbol x. EndYear[label] gives the minimal end year in the data defined up to the last SetData statement, for which all data are present. EndYear[x_list, label] computes an end year from the list (but this is not reset at EndYear[label]. Also see ResetData."

Labels::usage = "Labels is the list of labels"

Types::usage = "Types[x] gives a list of Symbols applicable to x, as given by the associated rule in NamesList[x]. \nBy default Types[]:\nwn = current value (millions)\nvn = value in prices last year (Laspeyres volume)\nvr = volume rate of change (Laspeyres)\ncn = volume constant prices (chained)\npr = price rate of change (Paasche)\npi = price index (chained)";

Types[] = {wn, vn, vr, cn, pr, pi};

Years::usage = "Years[concept] list of integer values for which there are data for concept"

SumOverSectors::usage = "SumOverSectors[x_,  c_, y_, lis_List] sets x<>c<>y to the sum over x<>c<>lis[[i]]:\nGenerally a sum of the same concept over various sectors. If c = Null, then the Sum is mapped over {wn, vn}"

SumOverConcepts::usage = "SumOverConcepts[x_,  c_, y_, lis_List] sets x<>c<>y to the sum over lis[[i]]<>c<>y:\nGenerally a sum within the same sector over various concepts. If c = Null, then the Sum is mapped over {wn, vn}"

SetROC::usage = "SetROC[x, y, z (, beginyear_:StartYear, label___)] applies SetData to x -> RateOfChange[y, z], which works when x is an undefined Symbol or String\nSetROC[x, pr, y, b, l] gives x<>pr<>y as the rate of change of wn and vn\nSetROC[x, vr, y, b, l] gives x<>vr<>y as the rate of change of vn and lagged wn"

NamesList::usage = " NamesList[concept] gives the list of variable names available for a concept, where a variable name is a String, and ToValue[variable] generates data. The list of variables is found by combining the Types and Sectors, found in Options[concept]. Note that it is possible to define and undefine explicit lists, by Set and Unset on NamesList[concept] "

ResetData::usage = "ResetData clears Data and Variates, and resets BeginYear and EndYear to -/+ Infinity"

Sectors::usage = "Sectors[] or Sectors[concept], list of symbols of the economic sectors";

SetData::usage = "SetData[x -> y  (, b, label)] for symbol x and list y, will Clear[x] and assign values so that:\n   {x[b], ..., x[b+n-1]} == y\nwhere n is the length of the datalist y.\nSetData[x_List (, b, label)] maps over the list.\nThe data can also be retrieved from Data[x, label].\nDefault begin is StartYear, and default label is empty";

StartYear::usage = "StartYear gives the year of the first Data, so that var[t - StartYear + 1] gives the proper position and value for year t. Default 1.";

Store::usage = "Store[x, b, e, label] puts the current values of x[i] for the range b up to e into Data[x, label]; and maps over x if it is a list"

Variates::usage = "Variates[label] gives the variates for which data have been set"

ToValue::usage = "ToValue[x__, {label}] gives Data[ToSymbol[x], label]"


Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
