(*********************************************************************

	Cool`Dbase`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995 Thomas Cool *)
(* :Package Version: 2.0 Thomas Cool, July 1997*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:    *)
(* :Limitation:
*)

(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`Dbase`", Join[{}, $Cool]]

Options[PutIntoDC] = Options[PutIntoContexts]

CollectDC::usage = "CollectDC[y_String] collects data from DataContexts"

ClearDCVariable::usage = "ClearDCVariable[x_String] \n clears the variable with that name in all DataContexts"

DCinPath::usage = "DCinPath puts the DataContexts-contexts into the $ContextPath"

PutIntoDC::usage = "PutIntoDC[y_String, f_String, x_String (,opts)] maps y=f[x] into contexts. Default has x in DataContexts."

FromFile::usage = "User defined: the Options from file, alternative to Options[Dbase], whenever FromFileQ = True."

VariableNames::usage = "VariableNames is the generic name for the list of names (Strings) of variables, when writing to the datafiles. Depending upon the context, this concerns all variables or just the selected variables."

DB::usage = "Subroutine for selecting DataContexts and SelectedVariables either from DbaseContext or -File or from Options[Dbase]. The decision is decided by FromFileQ in Options[Dbase]"

Dbase::usage ="Dbase[] or Dbase[{r___Rule}] is basic.\n The data contexts and selected variables are stored into a 'Dbase' package to provide a selection for ReadPackage. One has to provide a filename and a 'Dbase' context. Supposedly there are more projects with various stages of development requiring their own dbases. Defaults are in Options[Dbase].\n Give Dbase[Options] to show where Strings are required.\nDbase[Options] for the input form of the options.\nDbase[SetOptions, dir_, context_, lfn_:] if you want to make the options for project filename and context the same. If lfn === Null, then context and lfn are the same.\nDbase[Query, q_String, x__] automatically inserts the Dbase contexts in the Query. You should try Dbase[Query, \"??\", \"\"]"

(** Options Dbase **)

Options$Dbase::usage = "The settings of Options[Dbase] at loading Cool`Dbase`. When the user adapts Options[Dbase], it may be good to keep this in store without needing to load the package again. See ResetOptions."

Options$Dbase = {DbaseFile -> "C:\\Math3.0\\Dump\\Pro1Dba1.m",
		DbaseContext -> "Pro1Dba1`", 
		FromFileQ -> False,
		SelectedVariables -> {"nr", "datum1", "datum2"},
		DataContexts -> {"d1`", "d2`"},
		DbaseTest -> {{True, 1}, {"nr", 2}}}

Options[Dbase] = Options$Dbase

DbaseContext::usage = "User supplied option in Options[Dbase]: The name of the database context where the selection of variables is kept. Default is Project 1's Dbase 1: "<> ToString[InputForm[DbaseContext /.Options[Dbase]]]

DataContexts::usage = "User supplied option in Options[Dbase]: List of String codes for the data contexts. These context names are generally the same as the actual data package names. Note: the last ` may be dropped. Default is: "<> ToString[InputForm[DataContexts /.Options[Dbase]]]

DbaseFile::usage = "User supplied option in Options[Dbase]: The name of the project & data selection package. Default is:"<> ToString[InputForm[DbaseFile /.Options[Dbase]]]

FromFileQ::usage = "User supplied option in Options[Dbase].\n If True, then options are taken from FromFile (which is set to a value by reading a project-stage DbaseFile package first).\n If False, then these options are taken from the Options[Dbase].\n This Q has no role when creating a project-stage DbaseFile.\n Default is: "<> ToString[InputForm[FromFileQ /.Options[Dbase]]]

DbaseTest::usage = "User supplied option in Options[Dbase], usable for ToString[Input tests. Default is:\n"<> ToString[InputForm[DbaseTest /.Options[Dbase]]] <>  "\nBy default, the variable \"nr\" is taken to denote the 'code number' of the observations, such that the context definition can be found as the first two positions of the code. E.g. co`nr = {co001, co002, co003....}. In Cool`DifData` this default data definition is used to check whether various non-Mathematica files concern the same context"

SelectedVariables::usage = "User supplied option in Options[Dbase]: the variable Selection list. FromFileQ controls whether this selection is taken from Options or from DbaseContext`FromFile."

(** End options Dbase **)

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
