(*********************************************************************

	Cool`GenePro`Estimation`  package


 *********************************************************************)


(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995 Thomas Cool *)
(* :Package Version: 2.0,  June 1997.*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:  Genetic Programming, Estimation   *)
(* :Limitation: *)
(* :License: use of this software file requires a license, usually available
      by payment of $39 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)
(* :Comment: See the Cool`GenePro` package.*)

Needs["Cool`Common`"]

BeginPackage["Cool`GenePro`Estimation`", Join[{"Cool`Statistics`Common`", 
"Statistics`LinearRegression`", "Statistics`DataManipulation`", "Statistics`DescriptiveStatistics`", 
"Statistics`Common`RegressionCommon`",
"Cool`GenePro`"}, $Cool]]

Options[Estimation] = Sort[{TestPrintQ -> False, Data -> {}, EvaluationPerTest -> 1, ExeQTime -> .01,  NumberOfTests -> 1}]

Data::usage = Key[AddedUsage, Data, "Keyword for Estimation for the data list, see Options[Estimation]. Note: if data are integers, then some random functions may take much computing time. Therefor data are internally set to reals."]

Estimation::usage = "Estimation[individual] is a fitness test for estimation, and gives {hit, score} = {indicator, sum of squared errors}. The indicator is 1 iff the endogenous variable occurs in the rhs. The population is normally created with the lhs excluded. If the lhs is included, then the risk exists that lhs = lhs is the best estimate."

RuleToR2::usage = "RuleToR2[rule or list of rules] gives the R2 statistics associated with the rule(s) rhs -> sse. Coefficients that occur in different places are counted as one for the degrees of freedom."

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
