(*********************************************************************

	Cool`Leontief`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995/96 Thomas Cool *)
(* :Package Version: 2.00,  June 1996.*)
(* :Mathematica Version: 2.2.2 *)
(* :Keywords:    *)
(* :Limitation: *)
(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)
(* :References: A. Takayama, "Mathematical Economics", The Dryden Press*) 

Needs["Cool`Common`"]

BeginPackage["Cool`Leontief`", Join[{}, $Cool]]


IOAnalysis::usage = "IOAnalysis[A_List] for basic Input-Output results.\n     The model is x = f + A x, for x = production, f = final demand, A x intersectoral deliveries, and A a nonnegative square matrix of input-output coefficients. The Leontief Inverse is (I - A)^-1. If the Leontief Inverse is not nonnegative, then some nonnegative f may result into negative x[i] elements. Therefor, to allow for nonnegative x and f (i.e. meaningful economics), the Frobenius Root of A must be smaller than 1. Note: the root found here is normalised.\nIOAnalysis[A_List, B_List] for the forward Dynamic Leontief Model.\n     This model adds f = c + i, for c = consumption, i = investments. With k = B x the stock of capital, and B a nonnegative square matrix of capital requirement coefficients, then i = B.(x(+1)-x). The closed model (c = 0) generates the difference equation x(t+1) = (I + B^-1(I - A)) x(t). This shall be written as x(t+1) = (I + F) x(t). The main question is whether this system is relatively stable, i.e. that any deviation will return to a nonnegative path. There exists a Frobenius root for F^-1 = (I - A)^-1.B, which matrix is called the Dynamic Leontief Inverse. When F^-1 > 0, when its inverse F exists, and when r = (1 + 1/fr(F^-1)) dominates the other roots of (I + F), then and only then there is a relatively stable solution.\nThis routine does not check on indecomposability."

IOMatrixQ::usage = "IOMatrixQ[x_List] tests for a nonnegative square matrix"

LeontiefInverse::usage = "LeontiefInverse[A] = (I - A)^-1, see IOAnalysis"

PositiveMatrixQ::usage = "PositiveMatrixQ[x] tests whether x is a positive matrix" 

NonNegativeMatrixQ::usage = "NonNegativeMatrixQ[x] tests whether x is a nonnegative matrix" 

FrobeniusRoot::usage = "Keyword for IOAnalysis output. FrobeniusRoot the real eigenvalue with largest absolute value and associated with a nonnegative eigenvector (called the FrobeniusVector)."

FrobeniusVector::usage = "Keyword for IOAnalysis output. The vector is normalised so that the first element is 1." 

DynamicLeontiefInverse::usage = "Keyword for (I - A)^-1 . B, see IOAnalysis"

DynamicLeontiefMatrix::usage = "Keyword for B^-1 . (I - A), see IOAnalysis"

RelativeStabilityQ::usage = "Keyword for relative stability. With the Dynamic Leontief Inverse F^-1: if F^-1 > 0, if F exists, and if r = (1 + 1/fr(F^-1)) dominates the other roots of (I + F), then and only then there is a relatively stable solution. See IOAnalysis. "

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
