(******************************************************************

	Cool`LevelCES`  package


 ******************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1995/1997 Thomas Cool *)
(* :Package Version: 2.0,  June 1997.*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:    *)
(* :Limitation: *)
(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)


Needs["Cool`Common`"]

BeginPackage["Cool`LevelCES`", Join[{"Cool`CES`","Cool`Economic`Common`"}, $Cool]]

Cost::usage = Key[AddedUsage, Cost, "Cost[LevelCES, opts___Rule] gives the cost structure of a LevelCES function"]

Options$LevelCES::usage = "Makes options available for a ResetOptions[LevelCES]; the current settings of Options[Aggregator] are taken; so perhaps you wish to do ResetOptions[Aggregator] first"

Results$LevelCES = Results$Aggregator;
SetResults[LevelCES, Clear -> True];

FactorPosition::usage = Key[AddedUsage, FactorPosition, 
"FactorPosition[LevelCES, copt_List] gives the position within levels. (Using the FactorsSettings and LevelCES options.)"]

LevelCESAnalyser::usage = "LevelCESAnalyser[opts___Rule] analyses the structure given by LevelCES -> s, defines required Options[LevelCES], and puts the output on hold: Hold[CES][result]. (LevelCES only calls ReleaseHold.) Within Hold, Position gives the level."

LevelCES::usage = "LevelCES[opts___Rule]  analyse the structure s given by option LevelCES -> s, define the required Options[LevelCES], and give the function. Options like Factors -> ... etc. are used to reset the Options[CES]. Default labels for Constant, Ces and Return for the separate levels are taken from Options[CES]. The LevelCES stores the LevelCES parameter. If you set LevelCES -> {}, then a call of LevelCES[] stops without resetting the Options. Use SetFunction[LevelCES, ...] for more control of the naming of variables and parameters."

LevelCESRule::usage = "LevelCESRule develops FactorSettings, and thus gives a set of rules that are basically independent of Options[CES]. See SimplifyBy."

LevelCESlevel::usage = "LevelCESlevel[opts___Rule] gives the level within the LevelCES associated with Factor. The Factor option may also be set to implicit level values."

Position::usage = Key[AddedUsage, Position, "The positions of the levels. With leveli = {{1, 2}} and number of factors ni, there are factors FactorX[1, 2, 1] till FactorX[1, 2, ni]"]

SubCESNoFactors::usage = "SubCESNoFactors[n] sets the maximum number of factors in the CES used in sublevels to n"

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
