(*******************************************

	Cool`Money`  package


 *******************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1998 Thomas Cool *)
(* :Package Version: 1.00,  July 1998.*)
(* :Mathematica Version: 3.0.0 *)
(* :Keywords:    *)
(* :Limitation: *)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of packs. See the License[] function.
 *)

Needs["Cool`Common`"]

BeginPackage["Cool`Money`", Join[{"Miscellaneous`Units`", "Cool`Databank`", "Cool`Economic`Common`", "Cool`Time`"}, $Cool]]

Dollar::usage = "Money unit of the United States of America"

ERBank::usage = "Databank object for storage of exchange rates. The DataMold states that data are identified by a date and label, while the valuta are mentioned in the second element of its DataMold. See Valuta. The date has a financial format F[] (Databank cannot deal with List elements), and the label is a String. Rate data are pure numbers, but see Explain"


(*this here to declare the names*)

Options[ERBank] = {DataMold -> {{Date, Label}, 
		{DM, Euro, Franc, Guilder, Lire, Peseta, UKPound, Yen}}}


ExchangeRates::usage = "ExchangeRates[] gives the rates as specified in Options[ExchangeRates]\nExchangeRates[{Date, Label, Databank}] first sets these options using SetExchangeRates. Defaults are taken from the Options[ExchangeRates].\nThe result is the exchange rates of the specified Date, Label and Databank as {Name -> x Dollar, ...} where x is the value in Dollars"

FromDollarRates::usage = "FromDollarRates[sel] inverts the ExchangeRates[sel]"

FromDollar::usage = "FromDollar[expr, v_Symbol, sel___] applies the rate for valuta v in FromDollarRates[sel]"

MoneyConvert::usage = "MoneyConvert[old, new, sel___] converts old to new, using the databank entry sel. The default rates are taken from the Rule option in Options[ExchangeRates]. Another selection can be given as {Date, Label, Databank}, also with defaults from these options" 

ToDollar::usage = "ToDollar[expr, selection___] converts to Dollar, using 
ExchangeRates[selection]";

$Convert::usage = "$Convert[old, new, sel] is MoneyConvert while using FromMoneySymbols and ToMoneySymbols"


ToMoneySymbols::usage = "List of replacement rules from money keys to their symbols"

FromMoneySymbols::usage = "Reversed ToMoneyRules"

ToMoneySymbols = {Dollar -> $, Yen -> \[Yen], UKPound -> \[Sterling], Guilder -> \[Florin]};

FromMoneySymbols = Reverse /@ ToMoneySymbols;

ToExpression[ToString[#] <> "::usage = \"Symbol of a money unit\""]& /@
	(Last /@ ToMoneySymbols);

Valuta::usage = "Valuta[b] takes the second element of the DataMold of databank b, giving the list of currencies, excluding Dollar. Valuta[] takes its names from Options[ExchangeRates]"

SetExchangeRates::usage = "SetExchangeRates[{date_F, label_String, bank_Symbol}] selects the exchange rates from the database, and sets the options of ExchangeRates. You can use the symbols Date, Label, Databank as placeholders to use the defaults in Options[ExchangeRates] (so that you do not need to always type the databank)"

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
