(******************************************************************

	Cool`ShiftCES`  package


 ******************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Thomas Cool *)
(* :Package Version: 2.0,  June 1997.*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:    *)
(* :Limitation:
*)
(* :Comments:
This is not a swell package. It still serves two purposes. With the CES as y = f[x; c] with factors x and coefficients c (adding up to unity), we can define a function where the factors are shifted, as y = f[x - c y; c].  This is no longer a CES. But this function helps us to understand the limit properties where the CES turn into a Line, Leontief or Cobb-Douglas function. While the CES allows boundary values x -> 0, except in the Leontief case, the shifted CES is as strict as the Leontief case, since the boundaries are x -> c y. Secondly, the package is an application of the Economic`Common` package. The Shifted CES is an implicit function, but this is only a complication.
*)

(* :License: use of this software file requires a license, usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]


BeginPackage["Cool`ShiftCES`", Join[{"Cool`CES`", "Cool`Economic`Common`"}, $Cool]]


ShiftCES::usage = "ShiftCES[opts___Rule], input format like the CES[], shifts the function, so that it actually is no CES[]. It is also a label for FactorDemand[] and MarginalProduct[]";

NShiftCES::usage = "NShiftCES[Set, opts___Rule] sets parameters at a value and calls ShiftCES[], so that computations later on can be faster. \nNShiftCES[opts___Rule] actually computes the aggregate value of the implicit function by using FindRoot";

ShiftCESrhs::usage = "Label only. FunctionDomainQ[ShiftCESrhs, opts] or FunctionDomainQ[ShiftCESrhs, factors_List, aggregate, factorcoefficients] test on the domain of the right hand side of the ShiftCES, i.e. whether factors - aggregate * factorcoefficients is nonnegative. Defaults are taken from Options[CES], that also can be set with NShiftCES[Set, opts]";

ShiftCESContours::usage = "See the input format of CESContours[]";


(*SetOptions[CES, Aggregate -> Production]*)

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
