(******************************************************************

	Cool`Time`  package


 *******************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1994/98 Thomas Cool *)
(* :Package Version: 2.07, July 1998.*)
(* :Mathematica Version: Windows 3.0.0 *)
(* :Keywords:     Finance, Date, Calendar *)
(* :Limitation:*)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`Time`", {"Miscellaneous`Units`", "Miscellaneous`Calendar`" }]

AnyToStandardDate::usage = "AnyToStandardDate[x] converts any date format into the standard format of a list of six integers. An option First -> year may be passed on to the String format."

AnyToCalendarDate::usage = "AnyToCalendarDate[x] converts any date format into the Calendar format of a list of three integers. An option First -> year may be passed on to the String format."

CoordiDate::usage = "CoordiDate[x] changes date into numerical value on time axis, using years of equal length, and neglecting leap year differences. An option First -> year may be passed on to the String format."

DateFormat::usage = "Give ??DateFormat to see the various date formats in use."


DayFraction::usage = "DayFraction[day_] explains a real number of days as {days, hours, minutes, seconds}"

DateQ::usage = "DateQ[x] tests whether x is a proper date. Options for Calendar and string format apply."

DateToDays::usage ="DateToDays[CalendarDate, Gregorian||Julian||Islamic] gives the number of days since {1,1,1} according to that calendar. Gregorian is taken as default."

DaysToDate::usage ="DaysToDate[integer number, Gregorian||Julian||Islamic] gives the standard date, counted as the number of days since {1,1,1} according to that calendar. Gregorian is taken as default."

Du::usage = "Du[d, m, y] inputfacility, transforms into Ft[m, d, y]"

F::usage ="F[m, d, y] finance date object"

FQ::usage = "FQ[F[_]] applies DateQ to finance date. Can also be used as in {F[...], F[...], ...} /. F -> FQ"

FDate::usage = "FDate[]  = ToFinancialDate[ Date[]  ]"

ToFinancialDate::usage ="ToFinancialDate[x] changes a standard date into a financial one"

FromFinancialDate::usage ="FromFinancialDate[x] changes a financial date into a standard one"

FSort::usage = "FSort[x_List] sorts a list of financial dates"

Ft::usage = "Ft[m|y, d, m|y] or Ft[F[_]] checks whether we have a date, and may transform a standard Mathematica date into financial date"

MakeDate::usage = "MakeDate[x_List] appends up to six 0's to get Date format"



IntegerToDate::usage = "IntegerToDate[x] changes 199012 or 19901231 format into Date format. The standard Mathematica integer date format is the number of seconds since January 1 1900, and thus has preference above this use of integers. (See FromDate and ToDate.) However, the present format may be helpful sometimes, e.g. as temporary input facility."

LeapQ::usage = "LeapQ[year] is True when year is a leap year and False otherwise. Default option is Calendar -> Gregorian."

NormedDuration::usage = "NormedDuration[{begin, end}, opts] or \nNormedDuration[begin, end, opts] gives a duration in days, from begin to end date, by using a primitive weighing scheme of standard lengths. This e.g. excludes leap years. A primitive method like this can be useful for abstract reasoning. The default options define the standard year of 365 days and the standard month of 365/12 days"


NoF::usage = "NoF[x__] removes F and returns Sequence@@({x} /. F -> List)"

RealToDate::usage = "RealToDate[x_] changes a real back into a Date; the inverse of CoordiDate"

StringToDate::usage = "StringToDate[x_, opts___Rule]  changes a String like \"950915\" into a proper six digit date list. Default option is First -> 1950, meaning that \"50mmdd\" is recognised as 1950 but lower digits as 20up"

Time::usage = "Keyword"

Days::usage = "Days[] gives the list of days"

legend = "input facility, reads easier and might cause less mistakes"
January::usage = legend
February::usage = legend
March::usage = legend
April::usage = legend
May::usage = legend
June::usage = legend
July::usage = legend
August::usage = legend
September::usage = legend
October::usage = legend
November::usage = legend
December::usage = legend

Remove[legend]

Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
