(*********************************************************************

	Cool`Economic`Graphics`  package


 *********************************************************************)



(* :Author: Thomas Cool *)
(* :Copyright: Copyright 1997 Thomas Cool *)
(* :Package Version: 1.01,  November 1997.*)
(* :Mathematica Version: 3.0 *)
(* :Keywords:   Economics, Lagrange *)
(* :Limitation:  *)
(* :License: use of this software file requires a license usually available
      by payment of $10 to Swift account ING.B.NL.2A 3736767 to the name of 
      Thomas Cool, Rotterdamsestraat 69, 2586 GH Scheveningen, Holland.
      Please inquire about the cost of file packs. See the License[] function. *)

Needs["Cool`Common`"]

BeginPackage["Cool`Economic`Graphics`", 
Join[{"Graphics`FilledPlot`", "Cool`Economic`Common`"}, $Cool]]

ConsumerSurplusFilledPlot::usage = "ConsumerSurplusFilledPlot[f, pstar, {
pmin, pmax}, opts___Rule] plots the demand function f[p] for the price range, while the consumers' surplus from pstar is coloured. If pstar = Automatic, then pstar is computed as the value that maximises revenue p f[p]. Results are in Results[ConsumerSurplusFilledPlot]"

ConsumerSurplusPlot::usage = "ConsumerSurplusPlot[{f, g}, points_List:{}, 
{pmin, pmax}, labels_List:{}, opts___Rule] divides the consolidated demand function (f+g)[p] in sub demand functions f[u] and g[v] so that the consumer surplus can be exploited. Points = {u, v, p} can be provided, and if points = {} then the price points are determined by revenue maximisation, i.e. by maximising p * (f+g)[p] and u * f[u] and v * g[v] respectively. Range {pmin, pmax} is a pair of numbers that provide the beginning and end of the price plotting range. Labels is a pair of strings that provide identifications of the functions in the plot. Results are in Results[ConsumerSurplusPlot], with Join -> ... giving the results for the consolidated demand function and Apart -> ... giving the results for the nonconsolidated case. Data are in the order u, v, p"

ElasticityPlot::usage = "ElasticityPlot[f[x], {x, xmin, xmax}, opts___Rule] 
plots f[x], x f[x] and Elasticity[f[x], x] for the given range. Options are 
passed on to Plot. NB: If f[x] is a demand function with x the price, then x f[x] gives revenue. If f[x] = A x^a then a is the price elasticity, and 
revenue will rise when a+1 > 0. NB. See ?LinExp"



Begin["`Private`"]
End[]
EndPackage[]
Print["This is a crippled package: it contains only the usage statements, no routines. Use of the proper software requires a user license.
See http://www.can.nl/~cool or write to Thomas Cool, Rotterdamsestraat 69, NL-2586 GH Scheveningen, Holland for ordering details"]
